<script setup lang="ts">
    import { computed } from "vue";

    const props = defineProps(["modelValue", "label", "density"]);
    const emit = defineEmits(["update:modelValue"]);

    const localValue = computed({
        get: () => inputToPickerFormat(props.modelValue),
        set: (value: any): void => {
            emit("update:modelValue", pickerToOutputFormat(value));
        },
    });

    function inputToPickerFormat(input: string | null | undefined) {
        if (input == null || input == undefined) {
            return null;
        }

        const [datePart, timePart] = input.split(" ");
        const [year, month, day] = datePart.split("-");
        const [hour, minute] = timePart.split(":");

        // Construct the new format
        const output = `${year}-${month}-${day}T${hour}:${minute}:00`;

        return output;
    }
    function pickerToOutputFormat(input: string | null | undefined) {
        if (input == null || input == undefined) {
            return null;
        }
        const [datePart, timePart] = input.split("T");
        const [year, month, day] = datePart.split("-");
        const [hour, minute] = timePart.split(":");

        // Construct the original format
        const output = `${year}-${month}-${day} ${hour}:${minute}:00`;

        return output;
    }
</script>

<template>
    <v-text-field type="datetime-local" :label="props.label" v-model="localValue" :density="props.density"> </v-text-field>
</template>
